BICO 1.1

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Pages
Public Member Functions | List of all members
CluE::CombinedEvaluation< T > Class Template Referenceabstract

Abstract class. Proxy based evaluation algorithms may be optimized by deriving from this class. More...

`#include <combinedevaluation.h>`

Inheritance diagram for CluE::CombinedEvaluation< T >:
Collaboration diagram for CluE::CombinedEvaluation< T >:

## Public Member Functions
virtual | ~CombinedEvaluation ()
virtual double | combinedcost (std::vector< std::vector< T * > > const &partitioning, std::vector< T > const &proxies) const =0
| Calculates the cost related to the proxies, based on the partitions. More...
virtual double | combinedcost (PartitionProvider< T > const &partitioning, ProxyProvider< T > const &proxies, unsigned int solutionIndex) const =0
virtual double | combinedcost (std::vector< T * > const &partition, T const &proxy) const =0
virtual double | combinedcost (PartitionProvider< T > const &partitioning, ProxyProvider< T > const &proxies, unsigned int solutionIndex, unsigned int elementIndex) const =0
virtual double | combinedcost (std::vector< std::vector< T * > > const &partitioning, std::vector< T * > const &proxies) const =0
| Calculates the cost related to the discrete proxies, based on the partitions. More...
virtual double | combinedcost (PartitionProvider< T > const &partitioning, DiscreteProxyProvider< T > const &proxies, unsigned int solutionIndex) const =0
virtual double | combinedcost (std::vector< T * > const &partition, T const *const proxy) const
virtual double | combinedcost (PartitionProvider< T > const &partitioning, DiscreteProxyProvider< T > const &proxies, unsigned int solutionIndex, unsigned int elementIndex) const =0
Public Member Functions inherited from CluE::Evaluation
virtual | ~Evaluation ()

## Detailed Description

### template<typename T>
class CluE::CombinedEvaluation< T >

Abstract class. Proxy based evaluation algorithms may be optimized by deriving from this class.

Evaluation algorithms requiring proxies and partitions for calculating the input's cost may derive from this class. Using an already existing partitioning instead of calucalting it based on a given set of proxies will speed up computation time.

Definition at line 20 of file combinedevaluation.h.

## Constructor & Destructor Documentation

template<typename T >

virtual CluE::CombinedEvaluation< T >::~CombinedEvaluation | ( |  | ) |
| inline virtual

Definition at line 22 of file combinedevaluation.h.

## Member Function Documentation

template<typename T >

virtual double CluE::CombinedEvaluation< T >::combinedcost | ( | std::vector< std::vector< T * > > const & | partitioning,
|  | std::vector< T > const & | proxies
| ) |  | const
| pure virtual

Calculates the cost related to the proxies, based on the partitions.

Note
  There are separate overloaded versions of this method for use with discrete proxies.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::CombinedEvaluation< T >::combinedcost | ( | PartitionProvider< T > const & | partitioning,
|  | ProxyProvider< T > const & | proxies,
|  | unsigned int | solutionIndex
| ) |  | const
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  solutionIndex | PartitionProvider and ProxyProvider index.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::CombinedEvaluation< T >::combinedcost | ( | std::vector< T * > const & | partition,
|  | T const & | proxy
| ) |  | const
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::CombinedEvaluation< T >::combinedcost | ( | PartitionProvider< T > const & | partitioning,
|  | ProxyProvider< T > const & | proxies,
|  | unsigned int | solutionIndex,
|  | unsigned int | elementIndex
| ) |  | const
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  solutionIndex | PartitionProvider and ProxyProvider solution index.
  elementIndex | Partition and proxy index.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::CombinedEvaluation< T >::combinedcost | ( | std::vector< std::vector< T * > > const & | partitioning,
|  | std::vector< T * > const & | proxies
| ) |  | const
| pure virtual

Calculates the cost related to the discrete proxies, based on the partitions.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

virtual double CluE::CombinedEvaluation< T >::combinedcost | ( | PartitionProvider< T > const & | partitioning,
|  | DiscreteProxyProvider< T > const & | proxies,
|  | unsigned int | solutionIndex
| ) |  | const
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  solutionIndex | PartitionProvider and ProxyProvider solution index.

Implemented in CluE::KMeansEvaluator< T >.

template<typename T >

double CluE::CombinedEvaluation< T >::combinedcost | ( | std::vector< T * > const & | partition,
|  | T const *const | proxy
| ) |  | const
| inline virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 67 of file combinedevaluation.h.

template<typename T >

virtual double CluE::CombinedEvaluation< T >::combinedcost | ( | PartitionProvider< T > const & | partitioning,
|  | DiscreteProxyProvider< T > const & | proxies,
|  | unsigned int | solutionIndex,
|  | unsigned int | elementIndex
| ) |  | const
| pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  solutionIndex | PartitionProvider and ProxyProvider index.
  elementIndex | Partition and proxy index.

Implemented in CluE::KMeansEvaluator< T >.

The documentation for this class was generated from the following file:

- src/base/combinedevaluation.h